org.deidentifier.arx

## Class ARXProcessStatistics.Step

- java.lang.Object
- - org.deidentifier.arx.ARXProcessStatistics.Step

All Implemented Interfaces:
  java.io.Serializable

Enclosing class:
  ARXProcessStatistics

    public static class ARXProcessStatistics.Step
    extends java.lang.Object
    implements java.io.Serializable

One individual anonymization step

Author:
  Fabian Prasser
See Also:
  Serialized Form

### Constructor Summary

Constructors
Constructor and Description
`Step(ARXLattice.ARXNode top, ARXLattice.ARXNode optimum, boolean isOptimal)` Creates a new instance
`Step(Transformation<?> top, Transformation<?> optimum, boolean isOptimum, int numRecords)` Creates a new instance

### Method Summary

All Methods Instance Methods Concrete Methods
`ARXProcessStatistics.Step` `clone()`
`int` `getDimension(java.lang.String attribute)` Returns the index of an attribute.
`int` `getGeneralization(java.lang.String attribute)` Returns the generalization for the attribute.
`java.util.Map<java.lang.String,java.lang.Integer>` `getHeader()` Maps attribute name to position
`int` `getMaximalGeneralization(java.lang.String attribute)` Returns the maximal generalization level for the attribute.
`int[]` `getMaximalTransformationLevels()` Returns the transformation as an array.
`java.util.List<QualityMetadata<?>>` `getMetadata()` Returns the metadata associated with the result, if any
`int` `getNumberOfRecordsTransformed()` Returns the number of records transformed in this step, `-1` if not known.
`java.lang.String[]` `getQuasiIdentifyingAttributes()` Returns the quasi identifiers.
`InformationLoss<?>` `getScore()` Returns a node's lower bound, if any.
`int` `getTotalGeneralizationLevel()` Returns the sum of all generalization levels.
`int[]` `getTransformation()` Returns the transformation as an array.
`boolean` `isNumberOfRecordsTransformedAvailable()` Returns whether it is known how many records have been transformed in this step.
`boolean` `isOptimal()` Returns whether the solution in this step is optimal

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Constructor Detail

#### Step

    public Step(ARXLattice.ARXNode top,
                ARXLattice.ARXNode optimum,
                boolean isOptimal)

Creates a new instance

Parameters:
  `optimum` -
  `isOptimal` -

#### Step

    public Step(Transformation<?> top,
                Transformation<?> optimum,
                boolean isOptimum,
                int numRecords)

Creates a new instance

Parameters:
  `headermap` -
  `top` -
  `optimum` -
  `isOptimum` -
  `numRecords` -

### Method Detail

#### clone

    public ARXProcessStatistics.Step clone()

Overrides:
  `clone` in class `java.lang.Object`

#### getDimension

    public int getDimension(java.lang.String attribute)

Returns the index of an attribute.

Parameters:
  `attribute` -
Returns:

#### getGeneralization

    public int getGeneralization(java.lang.String attribute)

Returns the generalization for the attribute.

Parameters:
  `attribute` -
Returns:

#### getHeader

    public java.util.Map<java.lang.String,java.lang.Integer> getHeader()

Maps attribute name to position

Returns:

#### getMaximalGeneralization

    public int getMaximalGeneralization(java.lang.String attribute)

Returns the maximal generalization level for the attribute.

Parameters:
  `attribute` -
Returns:

#### getMaximalTransformationLevels

    public int[] getMaximalTransformationLevels()

Returns the transformation as an array.

Returns:

#### getMetadata

    public java.util.List<QualityMetadata<?>> getMetadata()

Returns the metadata associated with the result, if any

Returns:
  the metadata

#### getNumberOfRecordsTransformed

    public int getNumberOfRecordsTransformed()

Returns the number of records transformed in this step, `-1` if not known.

Returns:
  the numRecordsTransformed

#### getQuasiIdentifyingAttributes

    public java.lang.String[] getQuasiIdentifyingAttributes()

Returns the quasi identifiers.

Returns:

#### getScore

    public InformationLoss<?> getScore()

Returns a node's lower bound, if any.

Returns:

#### getTotalGeneralizationLevel

    public int getTotalGeneralizationLevel()

Returns the sum of all generalization levels.

Returns:

#### getTransformation

    public int[] getTransformation()

Returns the transformation as an array.

Returns:

#### isNumberOfRecordsTransformedAvailable

    public boolean isNumberOfRecordsTransformedAvailable()

Returns whether it is known how many records have been transformed in this step.

Returns:

#### isOptimal

    public boolean isOptimal()

Returns whether the solution in this step is optimal

Returns: